/*
 *    siin alg:      stacktest.c Robert I. Pitts <rip@cs.bu.edu>
 */
#include <stdio.h>
#include <string.h>  /* pikkuse määramine strlen() */
#include "stack.h" /* siin asuvad  funktsioonid  tooks pinuga */
#include <stdlib.h>  /* mälukasutuseks, dynamic allocation */
 
/************************ Funktsioonid **********************/
void StackInit(stackT *stackP, int maxSize);           /* 1 */
void StackPush(stackT *stackP, stackElementT element); /* 2 */
int StackIsEmpty(stackT *stackP);                      /* 3 */
stackElementT StackPop(stackT *stackP);                /* 4 */
void StackDestroy(stackT *stackP);                     /* 5 */

int StackIsFull(stackT *stackP);
//typedef char stackElementT; selgitus kasutatud muutujale

/*typedef struct {
  stackElementT *contents;
  int maxSize;
  int top;
} stackT;    */

/************************ Peaprogramm **********************/
int main(void)
{
  stackT stack;    /* pinu symbolitele,stringile */
  char str[101];   /* kasutaja strigile muutuja kirjeldus */
  char *traverse;  /* viit strigis liikumiseks */

  /* stringi sisestus,mitte rohkem kui 100 symbolit*/
  printf("Sisesta string: ");

  gets(str);  /* loe rida */

  /* Initsializeeri pinu ja seda piisavalt suurena. 1 */
  StackInit(&stack, strlen(str));

  /* Liigu stringi pidi ja aseta iga symbol pinusse  2 */

  for (traverse = str; *traverse != NULL /*'\0'*/; traverse++) {
    StackPush(&stack, *traverse);
    printf("%c", *traverse); /*pinusse tulekud*/ 
    printf("\n");
  }

  printf("\nPinust  valjastatud symbolid: ");
  while (!StackIsEmpty(&stack)) /* kontrolli, kas pinu ei ole tyhi */
   {
    printf("%c", StackPop(&stack));  /* Vota iga symbol pinust ja prindi  3 */
   }
 printf("\n");
/* pinu eemaldamine malust 4 */
  StackDestroy(&stack);
   getchar();
   
  return 0;
}
